=== debian/changelog ===
ros-eloquent-dynamic-graph (4.2.2-1bionic) bionic; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Olivier Stasse <ostasse@laas.fr>  Mon, 27 Jul 2020 10:33:51 -0000
