=== debian/control ===
Source: ros-eloquent-dynamic-graph
Section: misc
Priority: optional
Maintainer: Olivier Stasse <ostasse@laas.fr>
Build-Depends: debhelper (>= 9.0.0), cmake, doxygen, git, graphviz, libboost-all-dev, libeigen3-dev, ros-eloquent-ros-workspace
Homepage: http://github.com/stack-of-tasks/dynamic-graph
Standards-Version: 3.9.2

Package: ros-eloquent-dynamic-graph
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, graphviz, libboost-all-dev, libeigen3-dev, ros-eloquent-ament-cmake, ros-eloquent-ros-workspace
Description: Dynamic graph library
